#include "iodefine.h"

#define	printf	((int (*)(const char *,...))0x00007c7c)
#define	scanf	((int (*)(const char *,...))0x00007cb8)

// ------------------------------------------------------------
#define ACK		1
#define NAK		-1

// ------------------------------------------------------------
unsigned short font_data[95][32];

// ------------------------------------------------------------
// Jn(start condition)𔭍s
void I2C_start(void)
{
	IIC2.ICCR2.BYTE = (IIC2.ICCR2.BYTE & 0xbf) | 0x80;
	while (!IIC2.ICSR.BIT.TDRE)
		;
}


// ~(stop condition)𔭍s
void I2C_stop(void)
{
	IIC2.ICSR.BIT.STOP = 0;
	IIC2.ICCR2.BYTE &= 0x3f;
	while (!IIC2.ICSR.BIT.STOP)
		;
}


char I2C_tx_byte(char data)
{
	IIC2.ICDRT = data;
	while (!IIC2.ICSR.BIT.TDRE)
		;
	if (IIC2.ICIER.BIT.ACKBR)
		return (NAK);
	else
		return (ACK);
}


// ------------------------------------------------------------
// EEPROMւ̃oCg
void I2C_EEwrite_byte(unsigned short adr, unsigned char data)
{
	char ack, ret, tmp;

	while (IIC2.ICCR2.BIT.BBSY)
		// BBSY == 1̊
		;

	// }X^M[hɐݒ
	IIC2.ICCR1.BIT.MST = 1;			// }X^[h
	IIC2.ICCR1.BIT.TRS = 1;			// M[h

	do {
		I2C_start();				// Jn𔭍s
		I2C_tx_byte(0xa0);			// Control byte𑗐M
		while (!IIC2.ICSR.BIT.TEND)
			;
		ack = IIC2.ICIER.BIT.ACKBR;
	} while (ack == 1);
	I2C_tx_byte((adr >> 8) & 0xff);	// AhX
	I2C_tx_byte(adr & 0xff);		// AhX
	I2C_tx_byte(data);				// ݃f[^
	while (!IIC2.ICSR.BIT.TEND)
		;

	I2C_stop();						// ~s

	// X[uM[hɖ߂Ă
	IIC2.ICCR1.BIT.MST = 0;			// X[u[h
	IIC2.ICCR1.BIT.TRS = 0;			// M[h

//	IIC2.ICSR.BIT.TEND = 0;		////////////
	IIC2.ICSR.BIT.TDRE = 0;		////////////
}


// EEPROMPoCgǂݏo
unsigned char I2C_EEread_byte(unsigned short adr)
{
	char ack, ret, tmp;

	while (IIC2.ICCR2.BIT.BBSY)
		// BBSY == 1̊
		;

	// }X^M[hɐݒ
	IIC2.ICCR1.BIT.MST = 1;			// }X^[h
	IIC2.ICCR1.BIT.TRS = 1;			// M[h

	do {
		I2C_start();				// Jn𔭍s
		I2C_tx_byte(0xa0);			// Control byte𑗐M
		while (!IIC2.ICSR.BIT.TEND)
			;
		ack = IIC2.ICIER.BIT.ACKBR;
	} while (ack == 1);
	I2C_tx_byte((adr >> 8) & 0xff);	// AhX
	I2C_tx_byte(adr & 0xff);		// AhX
	while (!IIC2.ICSR.BIT.TEND)
		;

	I2C_start();
	I2C_tx_byte(0xa1);				// Control byte𑗐M
	while (!IIC2.ICSR.BIT.TEND)
		;
	IIC2.ICSR.BIT.TEND = 0;
	IIC2.ICCR1.BIT.TRS = 0;			// M[h
	IIC2.ICSR.BIT.TDRE = 0;

	IIC2.ICIER.BIT.ACKBT = 1;		// ԓACK = 1 .. I
	IIC2.ICCR1.BIT.RCVD = 1;		// ŏIf[^
	tmp = IIC2.ICDRR;				// _~[[h

	while (!IIC2.ICSR.BIT.RDRF)
		// M҂
		;

	I2C_stop();						// ~𔭍s
	ret = IIC2.ICDRR;				// Mf[^
	IIC2.ICCR1.BIT.RCVD = 0;

	// X[uM[hɖ߂Ă
	IIC2.ICCR1.BIT.MST = 0;			// X[u[h
	IIC2.ICCR1.BIT.TRS = 0;			// M[h

	return (ret);
}


// ------------------------------------------------------------
// ------------------------------------------------------------
void main()
{
	int i, j, code;
	unsigned int adr;
	unsigned short tmp;

	PFC.PBCRL1.BIT.PB3MD = 4;		// PB3SDA[qɐݒ
	PFC.PBCRL1.BIT.PB2MD = 4;		// PB2SCL[qɐݒ

	STB.CR3.BIT._IIC2 = 0;			// X^oC
	IIC2.ICCR1.BIT.ICE = 1;			// I2CoXL
	IIC2.ICCR1.BIT.CKS = 3;			// 313kHz

	// EEPROMfont_dataǂݏo
	adr = 0;
	for (i = 0; i < 95; i++) {
		for (j = 0; j < 32; j++) {
			tmp = I2C_EEread_byte(adr++);
			tmp <<= 8;
			tmp |= I2C_EEread_byte(adr++);
			font_data[i][j] = tmp;
		}
	}

	// ȈՕ\
	while (1) {
		printf("R[h = 0x");
		scanf("%x", &code);

		for (i = 0; i < 32; i++) {
			for (j = 0; j < 16; j++) {
				if (@@@@@)
					printf("*");
				else
					printf(" ");
			}
			printf("\n");
		}
	}
}